﻿using Interconnection;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Timer
{
    class Controler
    {
        public Settings settings = new Settings();
        public DataTable dtResults;
        private IList<Association> _lAssociations = new List<Association>();
        private IList<Team> _lStartingList = new List<Team>();
        private IList<Team> _lResults = new List<Team>();
        private Codebooks _codebooks = Codebooks.GetInstance();
        private Main _formMain;
        private CustomizationUIComponet _customizationUIComponet = new CustomizationUIComponet();
        private SerialComunicator _serialComunicator;
        private string _receivedData;
        private bool _isWriteResultFirstTrack = false;
        private bool _isWriteResultSecondTrack = false;
        private bool _isWriteResultThirdTrack = false;
        private bool _isReseted = false;
        private bool _isResetThread = false;
        private int _actualTrack = 1;
        private int _previousTrack;        
        private bool _isChangeActualTrack = false;
        public int _iteratorForMock = 1000;
        public bool isMock = false;

        /*Thread delegate*/
        private delegate void DelegateUpdateLabes(string receivedData, Time firstTrack, Time secondTrack, Time thirdTrack);

        public Controler()
        {
            Thread threadSerialComunicator = new Thread(ReadData);
            threadSerialComunicator.IsBackground = true;
            threadSerialComunicator.Start();
            this.CreateColumnsForDataTableResults();
        }

        public Controler(Main formMain)
        {
            this._formMain = formMain;
            Thread threadSerialComunicator = new Thread(ReadData);
            threadSerialComunicator.IsBackground = true;
            threadSerialComunicator.Start();
            this.CreateColumnsForDataTableResults();
        }

        /*Working with serial port*/
        public void ReadData()
        {
            while (true)
            {
                if (isMock)
                {
                    this._iteratorForMock = this._iteratorForMock + 10;
                    ShowTime(MockData.GenerateTime(this._iteratorForMock));

                    Thread.Sleep(15);
                }
                else
                {
                    try
                    {
                        if (this._isResetThread)
                        {
                            this._serialComunicator.Reset();
                            this._isResetThread = false;
                        }
                        ShowTime(this._serialComunicator.Read());

                    }
                    catch (System.NullReferenceException)
                    {
                        Thread.Sleep(5000);
                    }
                }
            }
        }

        public void ResetTimer()
        {
            /*   try
               {
                   this._serialComunicator.Reset();
               }
               catch
               {
                   //Only for generate mock data.
               }*/

            this._isResetThread = true;
            this._iteratorForMock = 1000;
            this._isWriteResultFirstTrack = false;
            this._isWriteResultSecondTrack = false;
            this._isWriteResultThirdTrack = false;
            this._isReseted = true;
            this._receivedData = null;
            this._isChangeActualTrack = false;

        }

        public void TestConnectionSerialPort(int numberSelectedValue)
        {
            Interconnection.TimerType timerType = null;
            this._codebooks.dTypeTimers.TryGetValue(numberSelectedValue, out timerType);

            try
            {

                this._serialComunicator = SerialComunicator.GetInstance("COM" + this.settings.portNumber.ToString(), timerType.baudRate);
                this._serialComunicator.Read();
            }
            catch
            { MessageBox.Show("Na vybraném portu se nepodařilo připojít k časomíře. Prosím zkuste vybrat jíný port"); }
        }

        /*Backround worker*/
        private void UpdateLabes(string receivedData, Time firstTrack, Time secondTrack, Time thirdTrack)
        {
            if (!this._isReseted)
            {
                this._formMain.labelTimeFirstTrackLeft.Text = Time.TransformTime(firstTrack.left.time);
                this._formMain.labelTimeFirstTrackRight.Text = Time.TransformTime(firstTrack.right.time);
                this._formMain.labelTimeFirstTrackFinal.Text = Time.TransformTime(firstTrack.final.time);
                this._formMain.labelTimeSecondTrackLeft.Text = Time.TransformTime(secondTrack.left.time);
                this._formMain.labelTimeSecondTrackRight.Text = Time.TransformTime(secondTrack.right.time);
                this._formMain.labelTimeSecondTrackFinal.Text = Time.TransformTime(secondTrack.final.time);
                this._formMain.labelTimeThirdTrackLeft.Text = Time.TransformTime(thirdTrack.left.time);
                this._formMain.labelTimeThirdTrackRight.Text = Time.TransformTime(thirdTrack.right.time);
                this._formMain.labelTimeThirdTrackFinal.Text = Time.TransformTime(thirdTrack.final.time);
                this._receivedData = receivedData;

                //UpdateTeam
                if (firstTrack.final.isValid && !this._isWriteResultFirstTrack)
                    WriteResult(1, firstTrack, this._formMain.listBoxFirstTrack);

                if (secondTrack.final.isValid && !this._isWriteResultSecondTrack)
                    WriteResult(2, secondTrack, this._formMain.listBoxSecondTrack);

                if (thirdTrack.final.isValid && !this._isWriteResultThirdTrack)
                    WriteResult(3, thirdTrack, this._formMain.listBoxThirdTrack);

            }
            else
            {
                this._isReseted = false;
            }
        }

        public void setActualTrack(int trackNumber)
        {
            this._previousTrack = this._actualTrack;
            if (this._isChangeActualTrack == false)
            {
                this._isChangeActualTrack = true;
                if (this.settings.trackCount == 1)
                {
                    this._actualTrack = 1;
                }

                if (this.settings.trackCount == 2)
                {
                    if (trackNumber == 2)
                        this._actualTrack = 1;
                    else
                        this._actualTrack = 2;

                }

                if (this.settings.trackCount == 3)
                {
                    if (trackNumber == 3)
                        this._actualTrack = 1;
                    else
                        this._actualTrack++;
                }

            }
        }
        public void ShowTime(string receivedData)
        {

            if (receivedData != "")
            {
                var d = new DelegateUpdateLabes(UpdateLabes);

                Object[] objectList = ParsintTime(receivedData);
                try
                {
                    this._formMain.Invoke(d, objectList);
                }
                catch
                {//Main thread was closed.
                }
            }

        }

        //Parsint receivedData from external Timer
        public object[] ParsintTime(string receivedData)
        {
            Object[] objectList = new Object[4];
            string[] pole;
            pole = receivedData.Split(':');

            objectList[0] = receivedData;
            if (pole[0] == "2")
            {
                objectList[1] = new Time();
                objectList[2] = new Time();
                objectList[3] = new Time();

               if(this._isChangeActualTrack==false)
                objectList[this._actualTrack] = new Time(Convert.ToInt32(pole[3]), pole[4], Convert.ToInt32(pole[5]), pole[6]);
               else
                   objectList[this._previousTrack] = new Time(Convert.ToInt32(pole[3]), pole[4], Convert.ToInt32(pole[5]), pole[6]);
              
                /*
                objectList[1] = new Time(Convert.ToInt32(pole[3]), pole[4], Convert.ToInt32(pole[5]), pole[6]);
                objectList[2] = new Time(Convert.ToInt32(pole[9]), pole[10], Convert.ToInt32(pole[11]), pole[12]);
                if (pole.Length > 17)
                    objectList[3] = new Time(Convert.ToInt32(pole[15]), pole[16], Convert.ToInt32(pole[17]), pole[18]);
                else
                    objectList[3] = new Time();*/

            }
            else if (pole[0] == "4")
            {

                objectList[1] = new Time(Convert.ToInt32(pole[3]), pole[4], Convert.ToInt32(pole[5]), pole[6]);
                objectList[2] = new Time(Convert.ToInt32(pole[7]), pole[8], Convert.ToInt32(pole[9]), pole[10]);
                if (pole.Length > 17)
                    objectList[3] = new Time(Convert.ToInt32(pole[15]), pole[16], Convert.ToInt32(pole[17]), pole[18]);
                else
                    objectList[3] = new Time();

            }
            if (new Time(Convert.ToInt32(pole[3]), pole[4], Convert.ToInt32(pole[5]), pole[6]).final.time == 0)
            {
                objectList[1] = new Time(Convert.ToInt32(pole[1]), pole[2], Convert.ToInt32(pole[1]), pole[2]);
                objectList[2] = objectList[1];
                objectList[3] = objectList[1];
            }

            return objectList;
        }

        /*Working with results*/
        public void WriteResult(int trackNumber, Time time, ListBox listBox)
        {
            switch (trackNumber)
            {
                case 1:
                    this._isWriteResultFirstTrack = true;
                    break;
                case 2:
                    this._isWriteResultSecondTrack = true;
                    break;
                case 3:
                    this._isWriteResultThirdTrack = true;
                    break;
            }

            Team team = null;
            string teamDescription = "";
            if (listBox.Items.Count > 0)
            {
                if (listBox.Items[0].ToString().Substring(0, 1) == "*")
                {
                    listBox.Items.RemoveAt(0);
                }

                teamDescription = listBox.Items[0].ToString();
            }
            try
            {
                team = this._lStartingList.Where(item => item.description == teamDescription).FirstOrDefault();
                //    team = this._lStartingList.Where(item => item.trackNumber == trackNumber).OrderBy(item => item.startingNumber).ToList().First();
                team.startingNumber = team.startingNumber * 1000;
            }
            catch
            {
                // Může nastat stav, že na jedné trati je méně závodních týmů proto není tým nalezen.
            }

            if (team != null)
            {
                if (team.disciplineId != 0)
                {
                    team.lTimes.Add(time);

                    if (team.lTimes.Count == 1)
                        this._lResults.Add(team);

                    if (team.lTimes.Count == this.settings.roundCount)
                    {
                        this._lStartingList.Remove(team);
                        team.startingNumber = team.startingNumber / (int)Math.Pow(1000, this.settings.roundCount);
                    }
                }
                else
                {
                    //testing team
                    this._lStartingList.Remove(team);
                }

                if (listBox.Items.Count > 0)
                {
                    listBox.Items.RemoveAt(0);
                    listBox.Refresh();
                    this.CreateOrder(this._lResults);
                }
            }

            this.setActualTrack(trackNumber);
        }

        public void WriteInvalidResult(int trackNumber, ListBox listBox)
        {
            try
            {
                Time time = new Time();
                object[] objectList = ParsintTime(this._receivedData);
                time = (Time)objectList[trackNumber];
                if (!time.left.isValid)
                    time.left.SetDefault();
                if (!time.right.isValid)
                    time.right.SetDefault();

                time.final.SetDefault();
                this.WriteResult(trackNumber, time, listBox);
            }
            catch (Exception)
            {
                MessageBox.Show("Nebylo zpuštěno měření času časomíry. Není možné zapsant neplatný pokus.");
            }
        }

        private void CreateOrder(IList<Team> lTeams)
        {
            int order;
            if (lTeams.Count > 0)
                foreach (var category in this._codebooks.dCategories)
                {
                    order = 1;
                    IList<Team> lTeamsFiltr = lTeams.Where(item => item.firesportCategoryId == category.Key).ToList();

                    lTeamsFiltr = SortTeamResults(lTeamsFiltr);

                    foreach (var team in lTeamsFiltr)
                    {
                        team.order = order;
                        if (this.settings.startingPoints + -team.order > 0)
                            team.points = this.settings.startingPoints + 1 - team.order;
                        else
                            team.points = 0;
                        if (team.lTimes.Where(item => item.final.isValid == true).OrderBy(item => item.final.time).ToList().Count > 0)
                            order++;
                    }
                }
        }

        private IList<Team> SortTeamResults(IList<Team> lTeams)
        {
            for (int i = 0; i < lTeams.Count; i++)
            {
                for (int j = 0; j < lTeams.Count - i - 1; j++)
                {
                    Time current = lTeams[j].lTimes.Where(item => item.final.isValid == true).OrderBy(item => item.final.time).FirstOrDefault();
                    Time next = lTeams[j + 1].lTimes.Where(item => item.final.isValid == true).OrderBy(item => item.final.time).FirstOrDefault();

                    if (next == null && current == null)
                        continue;
                    if (current == null)
                    {
                        SwapTeamPosition(lTeams, j);
                        continue;
                    }
                    if (next == null)
                        continue;

                    if (next.final.time < current.final.time)
                    {
                        SwapTeamPosition(lTeams, j);
                    }
                }
            }

            return lTeams;
        }

        private IList<Team> SwapTeamPosition(IList<Team> lTeams, int index)
        {
            Team tmp = lTeams[index + 1];
            lTeams[index + 1] = lTeams[index];
            lTeams[index] = tmp;
            return lTeams;

        }

        /*Working with forms*/
        public void OpenDetailResult(int index)
        {
            Team team = (Team)this.dtResults.Rows[index][0];
            FormEditResult frm = new FormEditResult(team);

            if (frm.ShowDialog() == DialogResult.OK)
            {
                team = frm.GetFormData();
                this.CreateOrder(this._lResults);
            }
        }

        public void SetComboxData(ComboBox comboBoxAsociation, ComboBox comboBoxCloseCategoriesGroup, ComboBox comboBoxFiresportLeague, ComboBox comboBoxTypeTimer, ComboBox comboBoxResultsFiltr)
        {
            comboBoxAsociation.DisplayMember = "value";
            comboBoxAsociation.ValueMember = "key";
            comboBoxAsociation.DataSource = this._codebooks.GetAssociations();
            comboBoxAsociation.AutoCompleteCustomSource = CreateComboBoxAutoCompleteStringCollection();

            comboBoxCloseCategoriesGroup.DisplayMember = "value";
            comboBoxCloseCategoriesGroup.ValueMember = "key";
            comboBoxCloseCategoriesGroup.DataSource = this._codebooks.GetCloseCategoriesGroup();

            comboBoxResultsFiltr.DisplayMember = "value";
            comboBoxResultsFiltr.ValueMember = "key";
            comboBoxResultsFiltr.DataSource = this._codebooks.GetFiltrResults();
            comboBoxResultsFiltr.SelectedValue = 0;

            comboBoxFiresportLeague.DataSource = this._codebooks.lLegualages;

            comboBoxTypeTimer.DisplayMember = "value";
            comboBoxTypeTimer.ValueMember = "key";
            comboBoxTypeTimer.DataSource = this._codebooks.GetTypeTimers();
        }

        private AutoCompleteStringCollection CreateComboBoxAutoCompleteStringCollection()
        {
            string[] myArray = new string[this._codebooks.GetAssociations().Count];
            for (int i = 0; i < this._codebooks.GetAssociations().Count; i++)
            {
                KeyValuePair<int, string> k = (KeyValuePair<int, string>)this._codebooks.GetAssociations()[i];
                myArray[i] = k.Value;
            }

            var source = new AutoCompleteStringCollection();
            source.AddRange(myArray);
            return source;
        }

        public void SetTreeView(TreeView treeViewCategories)
        {
            this._customizationUIComponet.SetTreeViewCategories(treeViewCategories, this._codebooks.dCategories);
        }

        public void SetListBoxCompetition(ListBox listBoxFiresportCompetition, int year)
        {
            FiresportConnector firesportConnector = FiresportConnector.GetInstance(this.settings.currentLeguage);

            listBoxFiresportCompetition.DisplayMember = "value";
            listBoxFiresportCompetition.ValueMember = "key";
            ArrayList alCompetions = new ArrayList();
            try
            {
                foreach (var item in firesportConnector.GetCompetions(year))
                {
                    alCompetions.Add(new KeyValuePair<int, string>(item.id, item.name));
                }
            }
            catch (NullReferenceException)
            {
                alCompetions.Add(new KeyValuePair<int, string>(0, "Pro rok " + year.ToString() + " nejsou na firesportu vytvořeny žádné závody"));
            }
            catch (AggregateException)
            {
                alCompetions.Add(new KeyValuePair<int, string>(0, "Nejsete připojeni k internetu."));
                alCompetions.Add(new KeyValuePair<int, string>(1, "Zkontrolujte své připojení"));
            }
            listBoxFiresportCompetition.DataSource = alCompetions;
        }

        /*Function for working with prezentation*/
        public void AddAssociation(ComboBox comboBoxAssociation, TreeView treeViewCategories, TreeView treeViewPrezentation)
        {
            try
            {
                int firesportId = (int)comboBoxAssociation.SelectedValue;

                Association association = null;
                try
                {
                    association = this._lAssociations.Where(item => item.firesportId == firesportId).ToList().First();
                }
                catch
                {
                    association = new Association();
                    this._lAssociations.Add(association);
                }

                association.firesportId = (int)comboBoxAssociation.SelectedValue;
                association.name = comboBoxAssociation.Text;

                bool isCheckedLeastOne = false;
                foreach (TreeNode treeNodeParent in treeViewCategories.Nodes)
                {
                    foreach (TreeNode treeNodeChild in treeNodeParent.Nodes)
                    {
                        if (treeNodeChild.Checked)
                        {
                            Team team = new Team();
                            team.name = treeNodeChild.Text;
                            team.firesportCategoryId = (int)treeNodeChild.Tag;
                            team.firesportId = (int)comboBoxAssociation.SelectedValue;
                            Interconnection.Category interconnectionCategory;
                            this._codebooks.dCategories.TryGetValue(team.firesportCategoryId, out interconnectionCategory);
                            team.disciplineId = interconnectionCategory.disciplineId;
                            treeNodeChild.Checked = false;
                            try
                            {
                                association.dTeam.Add(treeNodeChild.Name, team);
                            }
                            catch
                            {
                                MessageBox.Show("Tým \"" + treeNodeChild.Name + "\" sboru \"" + association.name + "\" je již přidán v prezenční listině.");
                            }
                            isCheckedLeastOne = true;
                        }
                    }
                }
                if (!isCheckedLeastOne)
                {
                    MessageBox.Show("Musítě vybrat alespoň jeden tým pro prezenci.");
                    if (association.dTeam.Count == 0)
                        this._lAssociations.Remove(association);

                }
                this._customizationUIComponet.ReloadTreeViewPrezentation(treeViewPrezentation, this._lAssociations);
            }
            catch
            {
                MessageBox.Show("Musíte vybrat sbor, pro který chcete přidat tým.");
            }
        }

        public void RemoveItemsFromTreeViewPrezentation(TreeView treeViewPrezentation)
        {
            for (int i = treeViewPrezentation.Nodes.Count - 1; i >= 0; i--)
            {
                if (treeViewPrezentation.Nodes[i].Checked)
                {
                    this._lAssociations.RemoveAt(i);
                }
                else
                {
                    for (int j = treeViewPrezentation.Nodes[i].Nodes.Count - 1; j >= 0; j--)
                    {
                        if (treeViewPrezentation.Nodes[i].Nodes[j].Checked)
                        {
                            this._lAssociations[i].dTeam.Remove(treeViewPrezentation.Nodes[i].Nodes[j].Text);
                        }
                    }
                }
            }
            this._customizationUIComponet.ReloadTreeViewPrezentation(treeViewPrezentation, this._lAssociations);
        }

        /*Function for starting list*/
        public void CloseCategories(TreeView treeViewCategories, TreeView treeViewPrezentation, KeyValuePair<int, string> groupCategories)
        {
            IList<int> lCloseCategories = this._codebooks.GetCloseCategories(groupCategories.Key);

            bool prezentationIsEmpty = true;
            foreach (Association association in this._lAssociations)
            {
                foreach (KeyValuePair<string, Team> team in association.dTeam)
                {
                    if (lCloseCategories.Where(item => item == team.Value.firesportCategoryId).ToList().Count() != 0)
                    {
                        team.Value.prezentationClose = true;
                        prezentationIsEmpty = false;
                    }
                }
            }
            if (prezentationIsEmpty)
            {
                MessageBox.Show("Pro kategorii " + groupCategories.Value + " nejsou prezentovány žádné týmy. Není možné ji uzavřít.");
            }
            else
            {
                foreach (var item in lCloseCategories)
                {
                    this._customizationUIComponet.UpdateTreeViewCategories(treeViewCategories, item);
                }
                this._customizationUIComponet.ReloadTreeViewPrezentation(treeViewPrezentation, this._lAssociations);
                this.CreateStartingList(lCloseCategories);
            }
        }

        public bool IsCategoryClosed(int categoryKey)
        {
            foreach (var association in this._lAssociations)
            {
                Team team = association.dTeam.Where(item => item.Value.firesportCategoryId == categoryKey && item.Value.startingNumber != 0).FirstOrDefault().Value;
                if (team != null)
                    return true;
            }
            return false;
        }
        public void WriteStartingList(int groupCategoriesKey)
        {
            int disciplineId = this._codebooks.GetDisciplineIdByGroupCategoriesKey(groupCategoriesKey);
            WriteStartingList(this._lStartingList.Where(team => team.trackNumber == 1 && team.disciplineId == disciplineId && team.order == 0).OrderBy(team => team.startingNumber).ToList(), this._formMain.listBoxFirstTrack);
            if (this.settings.trackCount >= 2)
                WriteStartingList(this._lStartingList.Where(team => team.trackNumber == 2 && team.disciplineId == disciplineId && team.order == 0).OrderBy(team => team.startingNumber).ToList(), this._formMain.listBoxSecondTrack);
            if (this.settings.trackCount >= 3)
                WriteStartingList(this._lStartingList.Where(team => team.trackNumber == 3 && team.disciplineId == disciplineId && team.order == 0).OrderBy(team => team.startingNumber).ToList(), this._formMain.listBoxThirdTrack);
        }

        private void WriteStartingList(IList<Team> lTeams, ListBox listBox)
        {
            foreach (var team in lTeams.Where(item => item.startingNumber == 0).ToList())
            {
                listBox.Items.Add(team.description);
            }

            lTeams = lTeams.Where(item => item.startingNumber != 0).ToList();

            for (int i = 0; i < this.settings.roundCount; i++)
            {
                if (lTeams.Count > 0)
                    listBox.Items.Add("**** " + (i + 1).ToString() + ". kolo ****");
                foreach (var team in lTeams)
                {
                    listBox.Items.Add(team.description);
                }
            }

        }

        private void CreateStartingList(IList<int> lCloseCategories)
        {
            List<Team> lTeams = new List<Team>();

            foreach (Association association in this._lAssociations)
            {
                foreach (var team in association.dTeam)
                {
                    if (lCloseCategories.Where(item => item == team.Value.firesportCategoryId).ToList().Count() != 0 && team.Value.startingNumber == 0)
                    {
                        team.Value.description = team.Value.startingNumber + " - " + association.name + " " + team.Key;
                        lTeams.Add(team.Value);
                    }
                }
            }
            lTeams = lTeams.Select(team => team).OrderByDescending(x => x.countTeamInGroup).ToList();


            MixStartList(lTeams).ToList().ForEach(item => this._lStartingList.Add(item));

            foreach (Association association in this._lAssociations)
            {
                foreach (KeyValuePair<string, Team> team in association.dTeam)
                {
                    if (lCloseCategories.Where(item => item == team.Value.firesportCategoryId).ToList().Count() != 0)
                    {
                        team.Value.description = team.Value.startingNumber + " - " + association.name + " " + team.Key;
                    }
                }
            }
        }

        private IList<Team> MixStartList(IList<Team> lTeams)
        {
            int currentTrackNumber = 1;
            lTeams[0].trackNumber = currentTrackNumber;
            int countFirstTrack = 0, countSecondTrack = 0, countThirdTrack = 0;

            for (int i = 1; i < lTeams.Count; i++)
            {
                switch (currentTrackNumber)
                {
                    case 1:
                        countFirstTrack++;
                        break;
                    case 2:
                        countSecondTrack++;
                        break;
                    case 3:
                        countThirdTrack++;
                        break;
                }

                if (lTeams[i].firesportId == lTeams[i - 1].firesportId)
                    lTeams[i].trackNumber = currentTrackNumber;
                else
                {
                    if (currentTrackNumber > this.settings.trackCount)
                    {
                        currentTrackNumber = 1;
                    }
                    switch (currentTrackNumber)
                    {
                        case 1:
                            if (countFirstTrack > countSecondTrack && this.settings.trackCount > 1)
                                currentTrackNumber = 2;
                            break;
                        case 2:
                            if (countSecondTrack > countThirdTrack && this.settings.trackCount > 2)
                                currentTrackNumber = 3;
                            else if (countSecondTrack > countFirstTrack && this.settings.trackCount == 2)
                                currentTrackNumber = 1;
                            break;
                        case 3:
                            if (countThirdTrack > countFirstTrack && settings.trackCount == 3)
                                currentTrackNumber = 1;
                            break;
                    }
                    lTeams[i].trackNumber = currentTrackNumber;
                }
            }

            int startingNumberIterator;

            for (int i = 1; i <= this.settings.trackCount; i++)
            {
                IList<Team> lFiltrTeams = lTeams.Where(team => team.trackNumber == i).ToList();
                IDictionary<int, bool> dStratingNumbers = new Dictionary<int, bool>();
                for (int j = 1; j < lFiltrTeams.Count + 1; j++)
                {
                    dStratingNumbers.Add(j, false);
                }

                startingNumberIterator = 1;
                Team comperTeam = new Team();
                foreach (Team team in lFiltrTeams)
                {
                    if (comperTeam.firesportId == team.firesportId)
                    {
                        if (comperTeam.startingNumber + 3 > lFiltrTeams.Count - 1)
                            startingNumberIterator = comperTeam.startingNumber + 2;
                        else
                            startingNumberIterator = comperTeam.startingNumber + 3;
                    }
                    else
                    {
                        startingNumberIterator = 1;
                    }
                    if (startingNumberIterator > lFiltrTeams.Count)
                    {
                        startingNumberIterator = 1;
                    }

                    team.startingNumber = GetStartingNumber(ref dStratingNumbers, startingNumberIterator);

                    comperTeam = team;
                }
            }
            return lTeams;
        }

        private int GetStartingNumber(ref IDictionary<int, bool> dStratingNumners, int keyStartingNumber)
        {
            while (true)
            {
                if (dStratingNumners[keyStartingNumber] == false)
                {
                    dStratingNumners[keyStartingNumber] = true;
                    return keyStartingNumber;
                }
                keyStartingNumber++;
            }
        }

        /*Exporting functions*/
        public void ExportResultsToFiresport()
        {
            try
            {
                ExportResults.ToFiresport(this._lResults, this.settings);
            }
            catch (InvalidCastException)
            {
                MessageBox.Show("Chybně zadané přihlašovací údaje pro portál firesport. Prosím přejděte do sekce nastavení a vyplněte přihlašovací údaje.");
            }
        }

        public void ExportResultsToCSV()
        {
            ExportResults.ToCSV(this._lResults);
        }

        /* Working with DataTable*/
        private void CreateColumnsForDataTableResults()
        {
            this.dtResults = new DataTable();
            this.dtResults.Columns.Add("Object team", typeof(Team));
            this.dtResults.Columns.Add("description", typeof(string));
            this.dtResults.Columns.Add("leftTime", typeof(string));
            this.dtResults.Columns.Add("rightTime", typeof(string));
            this.dtResults.Columns.Add("finalTime", typeof(string));
            this.dtResults.Columns.Add("order", typeof(int));
            this.dtResults.Columns[0].ColumnMapping = MappingType.Hidden;
            this.dtResults.AcceptChanges();
        }

        private DataTable SetDataTableResults(IList<Team> lResults)
        {
            this.dtResults.Clear();
            foreach (var team in lResults.OrderBy(item => item.firesportCategoryId).ThenBy(item => item.order).ToList())
            {
                Time time = team.lTimes.Where(item => item.final.isValid == true).OrderBy(item => item.final.time).FirstOrDefault();
                if (time == null)
                {
                    time = team.lTimes
                        .OrderBy(item => item.final.time)
                        .ThenBy(item => item.left.time)
                        .ThenBy(item => item.right.time)
                        .FirstOrDefault();
                    this.dtResults.Rows.Add(team, team.TrimDescription(), Time.TransformTime(time.left.time), Time.TransformTime(time.right.time), "NP", team.order);
                }
                else
                    this.dtResults.Rows.Add(team,
                       team.TrimDescription(),
                       Time.TransformTime(time.left.time),
                       Time.TransformTime(time.right.time),
                       Time.TransformTime(time.final.time),
                       team.order
                       );
            }
            return this.dtResults;
        }

        public DataTable GetDataTableResults()
        {
            return SetDataTableResults(this._lResults);
        }

        public DataTable GetDataTableResultsFiltrByCategoryId(int categoryId)
        {
            return this.SetDataTableResults(this._lResults.Where(item => item.firesportCategoryId == categoryId).ToList());
        }

        /* Moc Data*/
        public void RemoveTestTeam()
        { }
        public void CreateTestTeam()
        {
            Team team = new Team();
            team.description = "Tým pro otestování časomíry";
            team.trackNumber = 1;
            team.startingNumber = 0;
            this._lStartingList.Add(team);

            team = new Team();
            team.description = "Tým pro otestování časomíry";
            team.trackNumber = 2;
            team.startingNumber = 0;
            this._lStartingList.Add(team);

            team = new Team();
            team.description = "Tým pro otestování časomíry";
            team.trackNumber = 3;
            team.startingNumber = 0;
            this._lStartingList.Add(team);

            this._formMain.listBoxFirstTrack.Items.Clear();
            this._formMain.listBoxSecondTrack.Items.Clear();
            this._formMain.listBoxThirdTrack.Items.Clear();

            WriteStartingList(this._lStartingList.Where(item => item.trackNumber == 1 && team.order == 0).OrderBy(item => item.startingNumber).ToList(), this._formMain.listBoxFirstTrack);
            if (this.settings.trackCount >= 2)
                WriteStartingList(this._lStartingList.Where(item => item.trackNumber == 2 && team.order == 0).OrderBy(item => item.startingNumber).ToList(), this._formMain.listBoxSecondTrack);
            if (this.settings.trackCount >= 3)
                WriteStartingList(this._lStartingList.Where(item => item.trackNumber == 3 && team.order == 0).OrderBy(item => item.startingNumber).ToList(), this._formMain.listBoxThirdTrack);

        }
        public void MockAll()
        {
            MockData m = new MockData();
            this._lAssociations = m.MockMan(this._lAssociations);
            this._lAssociations = m.MockWomen(this._lAssociations);
            this._lAssociations = m.MockAdolescents(this._lAssociations);
            this._lAssociations = m.MockKids(this._lAssociations);

            this._customizationUIComponet.ReloadTreeViewPrezentation(this._formMain.treeViewPrezentation, this._lAssociations);

        }

        public void MockMan()
        {
            MockData m = new MockData();
            this._lAssociations = m.MockMan(this._lAssociations);

            this._customizationUIComponet.ReloadTreeViewPrezentation(this._formMain.treeViewPrezentation, this._lAssociations);
        }

        public void MockWomen()
        {
            MockData m = new MockData();
            this._lAssociations = m.MockWomen(this._lAssociations);

            this._customizationUIComponet.ReloadTreeViewPrezentation(this._formMain.treeViewPrezentation, this._lAssociations);
        }

        public void MockKids()
        {
            MockData m = new MockData();
            this._lAssociations = m.MockKids(this._lAssociations);

            this._customizationUIComponet.ReloadTreeViewPrezentation(this._formMain.treeViewPrezentation, this._lAssociations);
        }

        public void MockAdolescents()
        {
            MockData m = new MockData();
            this._lAssociations = m.MockAdolescents(this._lAssociations);

            this._customizationUIComponet.ReloadTreeViewPrezentation(this._formMain.treeViewPrezentation, this._lAssociations);
        }

        public void MockOneAssociation()
        {
            MockData m = new MockData();
            this._lAssociations = m.MockOneAssociation(this._lAssociations);

            this._customizationUIComponet.ReloadTreeViewPrezentation(this._formMain.treeViewPrezentation, this._lAssociations);
        }
    }
}