﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Windows.Forms;

namespace Timer
{
    public partial class Main : Form
    {
        private Controler controler;

        public Main()
        {
            InitializeComponent();
            this.controler = new Controler(this);
            this.controler.SetComboxData(this.comboBoxAssociation, this.comboBoxCloseCategoriesGroup, this.comboBoxFiresportLeague, this.comboBoxTypeTimer, this.comboBoxResultsFiltr);
            this.controler.SetTreeView(this.treeViewCategories);
            this.SetSettings();
        }
        /*Settings*/
        private void SetSettings()
        {
            this.numericUpDownPort.Value = this.controler.settings.portNumber;
            this.numericUpDownNumberTrackCount.Value = this.controler.settings.trackCount;
            this.numericUpDownRoundCount.Value = this.controler.settings.roundCount;
            this.numericUpDownFiresportYear.Value = DateTime.Now.Year;
            this.controler.settings.currentLeguage = this.comboBoxFiresportLeague.SelectedValue.ToString();
            this.controler.SetListBoxCompetition(this.listBoxFiresportCompetition, (int)this.numericUpDownFiresportYear.Value);
        }

        private void buttonSetSetings_Click(object sender, EventArgs e)
        {
            this.controler.settings.trackCount = (int)this.numericUpDownNumberTrackCount.Value;
            this.controler.settings.portNumber = (int)this.numericUpDownPort.Value;
            this.controler.settings.firesportPassword = this.textBoxFiresportPassword.Text;
            this.controler.settings.firesportLogin = this.textBoxFiresportLogin.Text;
            this.controler.settings.currentLeguage = this.comboBoxFiresportLeague.Text;
            this.controler.settings.roundCount = (int)this.numericUpDownRoundCount.Value;
            this.controler.settings.firesportCompetitionId = (int)this.listBoxFiresportCompetition.SelectedValue;
            this.controler.TestConnectionSerialPort((int)this.comboBoxTypeTimer.SelectedValue);
            MessageBox.Show("Nastavení bylo uloženo");
        }

        private void numericUpDownFiresportYear_ValueChanged(object sender, EventArgs e)
        {
            this.controler.settings.currentLeguage = this.comboBoxFiresportLeague.Text;
            this.controler.SetListBoxCompetition(this.listBoxFiresportCompetition, (int)this.numericUpDownFiresportYear.Value);
        }

        private void comboBoxFiresportLeague_SelectedValueChanged(object sender, EventArgs e)
        {
            this.controler.settings.currentLeguage = this.comboBoxFiresportLeague.Text;
            this.controler.SetListBoxCompetition(this.listBoxFiresportCompetition, (int)this.numericUpDownFiresportYear.Value);
        }

        private void buttonResetTimer_Click(object sender, EventArgs e)
        {
            this.controler.ResetTimer();
        }

        /*Set invalid try*/
        private void buttonFirstTrackInvalid_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Přejete si zapsan neplatný pokus?", "Neplatný pokus", MessageBoxButtons.OKCancel) == DialogResult.OK)
                this.controler.WriteInvalidResult(1, this.listBoxFirstTrack);
        }

        private void buttonSecondTrackInvalid_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Přejete si zapsan neplatný pokus?", "Neplatný pokus", MessageBoxButtons.OKCancel) == DialogResult.OK)
                this.controler.WriteInvalidResult(2, this.listBoxSecondTrack);
        }

        private void buttonThirdTrackInvalid_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Přejete si zapsan neplatný pokus?", "Neplatný pokus", MessageBoxButtons.OKCancel) == DialogResult.OK)
                this.controler.WriteInvalidResult(3, this.listBoxThirdTrack);
        }

        /*Create prezentation*/
        private void buttonAddAssocation_Click(object sender, EventArgs e)
        {
            this.controler.AddAssociation(this.comboBoxAssociation, this.treeViewCategories, treeViewPrezentation);
            this.comboBoxAssociation.Text = null;
        }

        private void buttonRemoveAssocation_Click(object sender, EventArgs e)
        {
            this.controler.RemoveItemsFromTreeViewPrezentation(this.treeViewPrezentation);
        }

        /*Create starting list*/
        private void buttonCloseCategory_Click(object sender, EventArgs e)
        {
            KeyValuePair<int,string> category = (KeyValuePair<int,string>)this.comboBoxCloseCategoriesGroup.SelectedItem;

            if (this.controler.IsCategoryClosed(category.Key))
            {
                MessageBox.Show("Kategorie " + category.Value + " byla již jednou uzavřena nelze ji už uzavřít znovu.");
            }
            else
            {
                if (MessageBox.Show("Chystáte se uzavřít kategorii " + category.Value + ". "
                    + "Po uzavření nebude již možné prezentovat týmy pro kategorii " + category.Value + ". "
                    + "Opravdu chcete uzavřít kategorii " + category.Value + "?", "Uzavření kategorie - "
                    + category.Value, MessageBoxButtons.OKCancel) == DialogResult.OK)
                {
                    this.controler.CloseCategories(this.treeViewCategories, this.treeViewPrezentation, category);
                    this.controler.WriteStartingList(category.Key);
                }
            }
        }

        /*Working with dataGrid*/
        private void dataGridViewResults_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {
            this.controler.OpenDetailResult(this.dataGridViewResults.CurrentCell.RowIndex);
            this.UpdateDataGridView();
        }

        private void UpdateDataGridView()
        {
            if (this.comboBoxResultsFiltr.SelectedValue == null || (int)this.comboBoxResultsFiltr.SelectedValue == 0)
            {
                this.dataGridViewResults.DataSource = this.controler.GetDataTableResults();
            }
            else
            {
                this.dataGridViewResults.DataSource = this.controler.GetDataTableResultsFiltrByCategoryId((int)this.comboBoxResultsFiltr.SelectedValue);
            }
        }

        private void comboBoxResultsFiltr_SelectedValueChanged(object sender, EventArgs e)
        {
            this.UpdateDataGridView();
        }

        private void tabControl_MouseClick(object sender, MouseEventArgs e)
        {
            this.dataGridViewResults.DataSource = this.controler.GetDataTableResults();
            var m = dataGridViewResults.GetType().GetMethod("OnDataSourceChanged", BindingFlags.NonPublic  | BindingFlags.Instance);
            m.Invoke(this.dataGridViewResults, new object[] { EventArgs.Empty });
        }

        /*Export results*/
        private void buttonExportToFiresport_Click(object sender, EventArgs e)
        {
            this.controler.ExportResultsToFiresport();
        }

        private void buttonExportToCSV_Click(object sender, EventArgs e)
        {
            this.controler.ExportResultsToCSV();
        }

        /*Set mock Data*/
        private void buttonGenerateMocTime_Click(object sender, EventArgs e)
        {
            this.controler.isMock = true;
        }

        private void buttonSetManMock_Click(object sender, EventArgs e)
        {
            this.controler.MockMan();
        }

        private void buttonSetWomenMock_Click(object sender, EventArgs e)
        {
            this.controler.MockWomen();
        }

        private void buttonSetAdolescentsMock_Click(object sender, EventArgs e)
        {
            this.controler.MockAdolescents();
        }

        private void buttonSetKidsMock_Click(object sender, EventArgs e)
        {
            this.controler.MockKids();
        }

        private void buttonSetAllMock_Click(object sender, EventArgs e)
        {
            this.controler.MockAll();
        }

        private void buttonSetOneAssociationMock_Click(object sender, EventArgs e)
        {
            this.controler.MockOneAssociation();
        }

        private void Main_SizeChanged(object sender, EventArgs e)
        {
            int n = (this.Size.Width / 6) / 6;
            Font font = new Font("Arial", n);
            this.labelTimeFirstTrackLeft.Font = font;
            this.labelTimeFirstTrackRight.Font = font;
            this.labelTimeFirstTrackFinal.Font = font;

            this.labelTimeSecondTrackLeft.Font = font;
            this.labelTimeSecondTrackRight.Font = font;
            this.labelTimeSecondTrackFinal.Font = font;

            this.labelTimeThirdTrackLeft.Font = font;
            this.labelTimeThirdTrackRight.Font = font;
            this.labelTimeThirdTrackFinal.Font = font;
        }

        private void buttonCreateDumyStartTeam_Click(object sender, EventArgs e)
        {
            this.controler.CreateTestTeam();
        }

        private void buttonResetTimers_Click(object sender, EventArgs e)
        {
            this.controler.ResetTimer();
        }
    }
}