﻿using Interconnection;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Timer
{
    class MockData
    {
        private Codebooks codebooks = Codebooks.GetInstance();

        private Association GetAssociation(IList<Association> lAssociations, int firesportId)
        {
            Association association = null;
            try
            {
                association = lAssociations.Where(item => item.firesportId == firesportId).ToList().First();
            }
            catch
            {
                association = new Association();
                lAssociations.Add(association);
            }
            return association;
        }

        public IList<Association> MockKids(IList<Association> lAssociations)
        {
            Association a = GetAssociation(lAssociations, 171387);
            a.name = "Tuchoraz";
            a.firesportId = 171387;
            a.dTeam.Add("Starší Žáci A", new Team { name = "A", firesportCategoryId = 5, firesportId = 171387, countTeamInGroup = 2 });
            a.dTeam.Add("Mladší Žáci A", new Team { name = "A", firesportCategoryId = 6, firesportId = 171387, countTeamInGroup = 2 });


            a = GetAssociation(lAssociations, 66648);
            a.name = "Klučov";
            a.firesportId = 66648;
            a.dTeam.Add("Mladší Žáci A", new Team { name = "A", firesportCategoryId = 6, firesportId = 66648, countTeamInGroup = 3 });
            a.dTeam.Add("Mladší Žáci B", new Team { name = "B", firesportCategoryId = 6, firesportId = 66648, countTeamInGroup = 3 });
            a.dTeam.Add("Mladší Žáci C", new Team { name = "C", firesportCategoryId = 6, firesportId = 66648, countTeamInGroup = 3 });


            a = GetAssociation(lAssociations, 7016);
            a.name = "Kostelec nad Černými Lesy";
            a.firesportId = 7016;
            a.dTeam.Add("Starší Žáci A", new Team { name = "A", firesportCategoryId = 5, firesportId = 7016, countTeamInGroup = 3 });
            a.dTeam.Add("Starší Žáci B", new Team { name = "B", firesportCategoryId = 5, firesportId = 7016, countTeamInGroup = 3 });
            a.dTeam.Add("Mladší Žáci A", new Team { name = "A", firesportCategoryId = 6, firesportId = 7016, countTeamInGroup = 3 });


            a = GetAssociation(lAssociations, 147397);
            a.name = "Sendražice";
            a.firesportId = 147397;
            a.dTeam.Add("Starší Žáci A", new Team { name = "A", firesportCategoryId = 5, firesportId = 147397, countTeamInGroup = 2 });
            a.dTeam.Add("Mladší Žáci A", new Team { name = "A", firesportCategoryId = 6, firesportId = 147397, countTeamInGroup = 2 });


            a = GetAssociation(lAssociations, 117099);
            a.name = "Ovčary";
            a.firesportId = 117099;
            a.dTeam.Add("Starší Žáci A", new Team { name = "A", firesportCategoryId = 5, firesportId = 117099, countTeamInGroup = 3 });
            a.dTeam.Add("Mladší Žáci A", new Team { name = "A", firesportCategoryId = 6, firesportId = 117099, countTeamInGroup = 3 });
            a.dTeam.Add("Mladší Žáci B", new Team { name = "B", firesportCategoryId = 6, firesportId = 117099, countTeamInGroup = 3 });



            a = GetAssociation(lAssociations, 139742);
            a.name = "Ratenice";
            a.firesportId = 139742;
            a.dTeam.Add("Starší Žáci A", new Team { name = "A", firesportCategoryId = 5, firesportId = 139742, countTeamInGroup = 2 });
            a.dTeam.Add("Mladší Žáci A", new Team { name = "A", firesportCategoryId = 6, firesportId = 139742, countTeamInGroup = 2 });


            a = GetAssociation(lAssociations, 141445);
            a.name = "Rostoklaty";
            a.firesportId = 141445;
            a.dTeam.Add("Starší Žáci A", new Team { name = "A", firesportCategoryId = 5, firesportId = 141445, countTeamInGroup = 3 });
            a.dTeam.Add("Mladší Žáci A", new Team { name = "A", firesportCategoryId = 6, firesportId = 141445, countTeamInGroup = 3 });
            a.dTeam.Add("Mladší Žáci B", new Team { name = "B", firesportCategoryId = 6, firesportId = 141445, countTeamInGroup = 3 });


            a = GetAssociation(lAssociations, 170518);
            a.name = "Třebovle";
            a.firesportId = 170518;
            a.dTeam.Add("Mladší Žáci A", new Team { name = "A", firesportCategoryId = 5, firesportId = 170518, countTeamInGroup = 2 });
            a.dTeam.Add("Mladší Žáci B", new Team { name = "B", firesportCategoryId = 6, firesportId = 170518, countTeamInGroup = 2 });


            a = GetAssociation(lAssociations, 138754);
            a.name = "Zibohlavy";
            a.firesportId = 138754;
            a.dTeam.Add("Mladší Žáci A", new Team { name = "A", firesportCategoryId = 5, firesportId = 138754, countTeamInGroup = 2 });
            a.dTeam.Add("Mladší Žáci B", new Team { name = "B", firesportCategoryId = 6, firesportId = 138754, countTeamInGroup = 2 });


            a = GetAssociation(lAssociations, 29173);
            a.name = "Mančice";
            a.firesportId = 29173;
            a.dTeam.Add("Starší Žáci A", new Team { name = "A", firesportCategoryId = 5, firesportId = 29173, countTeamInGroup = 1 });


            a = GetAssociation(lAssociations, 191108);
            a.name = "Zásmuky";
            a.firesportId = 191108;
            a.dTeam.Add("Starší Žáci A", new Team { name = "A", firesportCategoryId = 5, firesportId = 191108, countTeamInGroup = 1 });


            a = GetAssociation(lAssociations, 31640);
            a.name = "Drahobudice";
            a.firesportId = 31640;
            a.dTeam.Add("Starší Žáci A", new Team { name = "A", firesportCategoryId = 5, firesportId = 31640, countTeamInGroup = 1 });


            return SetDisciplineId(lAssociations);
        }

        public IList<Association> MockOneAssociation(IList<Association> lAssociations)
        {
            Association a = GetAssociation(lAssociations, 147397);
            a.name = "Sendražice";
            a.firesportId = 147397;
            a.dTeam.Add("Muži A", new Team { name = "A", firesportCategoryId = 1, firesportId = 147397, countTeamInGroup = 1 });
            a.dTeam.Add("Starší Žáci A", new Team { name = "A", firesportCategoryId = 5, firesportId = 147397, countTeamInGroup = 2 });
            a.dTeam.Add("Mladší Žáci A", new Team { name = "A", firesportCategoryId = 6, firesportId = 147397, countTeamInGroup = 2 });
            a.dTeam.Add("Smíšený dorost A", new Team { name = "A", firesportCategoryId = 16, firesportId = 147397, countTeamInGroup = 1 });
            a.dTeam.Add("Ženy A", new Team { name = "A", firesportCategoryId = 2, firesportId = 147397, countTeamInGroup = 1 });


            return SetDisciplineId(lAssociations);
        }

        public IList<Association> MockMan(IList<Association> lAssociations)
        {
            Association a = GetAssociation(lAssociations, 138746);
            a.name = "Radovesnice I";
            a.firesportId = 138746;
            a.dTeam.Add("Muži A", new Team { name = "A", firesportCategoryId = 1, firesportId = 138746, countTeamInGroup = 1 });


            a = GetAssociation(lAssociations, 66648);
            a.name = "Klučov";
            a.firesportId = 66648;
            a.dTeam.Add("Muži A", new Team { name = "A", firesportCategoryId = 1, firesportId = 66648, countTeamInGroup = 2 });
            a.dTeam.Add("Muži B", new Team { name = "B", firesportCategoryId = 1, firesportId = 66648, countTeamInGroup = 2 });


            a = GetAssociation(lAssociations, 139742);
            a.name = "Ratenice";
            a.firesportId = 139742;
            a.dTeam.Add("Muži A", new Team { name = "A", firesportCategoryId = 1, firesportId = 139742, countTeamInGroup = 1 });


            a = GetAssociation(lAssociations, 117099);
            a.name = "Ovčáry";
            a.firesportId = 117099;
            a.dTeam.Add("Muži", new Team { name = "A", firesportCategoryId = 1, firesportId = 117099, countTeamInGroup = 1 });


            a = GetAssociation(lAssociations, 178047);
            a.name = "Vítězov";
            a.firesportId = 178047;
            a.dTeam.Add("Muži A", new Team { name = "A", firesportCategoryId = 1, firesportId = 178047, countTeamInGroup = 1 });



            a = GetAssociation(lAssociations, 170518);
            a.name = "Třebovle";
            a.firesportId = 170518;
            a.dTeam.Add("Muži A", new Team { name = "A", firesportCategoryId = 1, firesportId = 170518, countTeamInGroup = 1 });


            a = GetAssociation(lAssociations, 7016);
            a.name = "Kostelec nad Černými Lesy";
            a.firesportId = 7016;
            a.dTeam.Add("Muži", new Team { name = "A", firesportCategoryId = 1, firesportId = 7016, countTeamInGroup = 1 });


            a = GetAssociation(lAssociations, 172332);
            a.name = "Lžovice";
            a.firesportId = 172332;
            a.dTeam.Add("Muži A", new Team { name = "A", firesportCategoryId = 1, firesportId = 172332, countTeamInGroup = 1 });


            a = GetAssociation(lAssociations, 149187);
            a.name = "Církvice";
            a.firesportId = 149187;
            a.dTeam.Add("Muži A", new Team { name = "A", firesportCategoryId = 1, firesportId = 149187, countTeamInGroup = 1 });


            a = GetAssociation(lAssociations, 197441);
            a.name = "Končice";
            a.firesportId = 197441;
            a.dTeam.Add("Muži A", new Team { name = "A", firesportCategoryId = 1, firesportId = 197441, countTeamInGroup = 1 });


            return SetDisciplineId(lAssociations);
        }

        public IList<Association> MockWomen(IList<Association> lAssociations)
        {
            Association a = GetAssociation(lAssociations, 138746);
            a.name = "Radovesnice I";
            a.firesportId = 138746;
            a.dTeam.Add("Ženy A", new Team { name = "A", firesportCategoryId = 2, firesportId = 138746, countTeamInGroup = 1 });


            a = GetAssociation(lAssociations, 66648);
            a.name = "Klučov";
            a.firesportId = 66648;
            a.dTeam.Add("Ženy A", new Team { name = "A", firesportCategoryId = 2, firesportId = 66648, countTeamInGroup = 2 });
            a.dTeam.Add("Ženy B", new Team { name = "B", firesportCategoryId = 2, firesportId = 66648, countTeamInGroup = 2 });


            a = GetAssociation(lAssociations, 139742);
            a.name = "Ratenice";
            a.firesportId = 139742;
            a.dTeam.Add("Ženy A", new Team { name = "A", firesportCategoryId = 2, firesportId = 139742, countTeamInGroup = 1 });


            a = GetAssociation(lAssociations, 117099);
            a.name = "Ovčáry";
            a.firesportId = 117099;
            a.dTeam.Add("Ženy", new Team { name = "A", firesportCategoryId = 2, firesportId = 117099, countTeamInGroup = 1 });


            a = GetAssociation(lAssociations, 178047);
            a.name = "Vítězov";
            a.firesportId = 178047;
            a.dTeam.Add("Ženy A", new Team { name = "A", firesportCategoryId = 2, firesportId = 178047, countTeamInGroup = 1 });



            a = GetAssociation(lAssociations, 170518);
            a.name = "Třebovle";
            a.firesportId = 170518;
            a.dTeam.Add("Ženy A", new Team { name = "A", firesportCategoryId = 2, firesportId = 170518, countTeamInGroup = 1 });


            a = GetAssociation(lAssociations, 7016);
            a.name = "Kostelec nad Černými Lesy";
            a.firesportId = 7016;
            a.dTeam.Add("Ženy", new Team { name = "A", firesportCategoryId = 2, firesportId = 7016, countTeamInGroup = 1 });


            a = GetAssociation(lAssociations, 172332);
            a.name = "Lžovice";
            a.firesportId = 172332;
            a.dTeam.Add("Ženy A", new Team { name = "A", firesportCategoryId = 2, firesportId = 172332, countTeamInGroup = 1 });


            a = GetAssociation(lAssociations, 149187);
            a.name = "Církvice";
            a.firesportId = 149187;
            a.dTeam.Add("Ženy A", new Team { name = "A", firesportCategoryId = 2, firesportId = 149187, countTeamInGroup = 1 });



            return SetDisciplineId(lAssociations);
        }

        public IList<Association> MockAdolescents(IList<Association> lAssociations)
        {
            Association a = GetAssociation(lAssociations, 138746);
            a.name = "Radovesnice I";
            a.firesportId = 138746;
            a.dTeam.Add("Smíšený dorost A", new Team { name = "A", firesportCategoryId = 16, firesportId = 138746, countTeamInGroup = 1 });


            a = GetAssociation(lAssociations, 139742);
            a.name = "Ratenice";
            a.firesportId = 139742;
            a.dTeam.Add("Smíšený dorost A", new Team { name = "A", firesportCategoryId = 16, firesportId = 139742, countTeamInGroup = 1 });


            a = GetAssociation(lAssociations, 117099);
            a.name = "Ovčáry";
            a.firesportId = 117099;
            a.dTeam.Add("Smíšený dorost", new Team { name = "A", firesportCategoryId = 16, firesportId = 117099, countTeamInGroup = 1 });


            a = GetAssociation(lAssociations, 178047);
            a.name = "Vítězov";
            a.firesportId = 178047;
            a.dTeam.Add("Smíšený dorost A", new Team { name = "A", firesportCategoryId = 16, firesportId = 178047, countTeamInGroup = 1 });



            a = GetAssociation(lAssociations, 170518);
            a.name = "Třebovle";
            a.firesportId = 170518;
            a.dTeam.Add("Smíšený dorost A", new Team { name = "A", firesportCategoryId = 16, firesportId = 170518, countTeamInGroup = 1 });


            a = GetAssociation(lAssociations, 7016);
            a.name = "Kostelec nad Černými Lesy";
            a.firesportId = 7016;
            a.dTeam.Add("Smíšený dorost", new Team { name = "A", firesportCategoryId = 16, firesportId = 7016, countTeamInGroup = 1 });


            a = GetAssociation(lAssociations, 172332);
            a.name = "Lžovice";
            a.firesportId = 172332;
            a.dTeam.Add("Smíšený dorost A", new Team { name = "A", firesportCategoryId = 16, firesportId = 172332, countTeamInGroup = 1 });


            a = GetAssociation(lAssociations, 149187);
            a.name = "Církvice";
            a.firesportId = 149187;
            a.dTeam.Add("Smíšený dorost A", new Team { name = "A", firesportCategoryId = 16, firesportId = 149187, countTeamInGroup = 1 });


            a = GetAssociation(lAssociations, 197441);
            a.name = "Končice";
            a.firesportId = 197441;
            a.dTeam.Add("Smíšený dorost A", new Team { name = "A", firesportCategoryId = 16, firesportId = 197441, countTeamInGroup = 1 });


            return SetDisciplineId(lAssociations);
        }

        private IList<Association> SetDisciplineId(IList<Association> lAssociations)
        {
            foreach (var association in lAssociations)
            {
                foreach (var team in association.dTeam)
                {
                    Interconnection.Category interconnectionCategory;

                    this.codebooks.dCategories.TryGetValue(team.Value.firesportCategoryId, out interconnectionCategory);

                    team.Value.disciplineId = interconnectionCategory.disciplineId;

                }

            }

            return lAssociations;

        }

        public IList<Team> UpdateTimeInTeams(IList<Team> lTeams)
        {
            lTeams[4] = UpdateTimeInTeam(lTeams[4], 0);
            lTeams[7] = UpdateTimeInTeam(lTeams[7], 0);

            lTeams[8] = UpdateTimeInTeam(lTeams[8], 1);
            lTeams[10] = UpdateTimeInTeam(lTeams[10], 1);

            return lTeams;

        }

        private Team UpdateTimeInTeam(Team team, int index)
        {
            team.lTimes[index].final.isValid = true;
            return team;
        }

        public static string GenerateTime(int i)
        {
            string s = "2:";
            string t1Right = "", t2Right = "", t3Right = "";
            string t1Left = "", t2Left = "", t3Left = "";
            string t1Final = "", t2Final = "", t3Final = "";

            //T1
            if (i < 10000)
                t1Left = i.ToString() + ":2:";
            else
                t1Left = 10000.ToString() + ":8:";
            if (i < 16000)
            {
                t1Right = i.ToString() + ":2:";
                t1Final = i.ToString() + ":2:";
            }
            else
            {
                t1Left = 10000.ToString() + ":8:";
                t1Right = 16000.ToString() + ":8:";
                t1Final = 16000.ToString() + ":8:";
            }

            //T2
            if (i < 12000)
                t2Left = i.ToString() + ":2:";
            else
                t2Left = 12000.ToString() + ":8:";
            if (i < 13000)
            {
                t2Right = i.ToString() + ":2:";
                t2Final = i.ToString() + ":2:";
            }
            else
            {
                t2Left = 12000.ToString() + ":8:";
                t2Right = 13000.ToString() + ":8:";
                t2Final = 13000.ToString() + ":8:";
            }
            
            //T3
            if (i < 12000)
                t3Left = i.ToString() + ":2:";
            else
                t3Left = 12000.ToString() + ":8:";
            if (i < 13000)
            {
                t3Right = i.ToString() + ":2:";
                t3Final = i.ToString() + ":2:";
            }
            else
            {
                t3Left = 12000.ToString() + ":8:";
                t3Right = 13000.ToString() + ":8:";
                t3Final = 13000.ToString() + ":8:";
            }

            return s + t1Final + t1Left + t1Right + t2Final + t2Left + t2Right + t3Final + t3Left + t3Right + ":2";
        }

        public static string GenerateTime()
        {
            var rand = new Random();
            string s = "2:";
            string t1Right = "", t2Right = "", t3Right = "";
            string t1Left = "", t2Left = "", t3Left = "";
            string t1Final = "", t2Final = "", t3Final = "";

            //T1
            t1Left = rand.Next(10000, 50000).ToString() + ":8:";
            t1Right = rand.Next(5000, 10000).ToString() + ":8:";
            t1Final = t1Right;


            //T2
            t2Left = rand.Next(1000, 5000).ToString() + ":8:";
            t2Right = rand.Next(5000, 10000).ToString() + ":8:";
            t2Final = t2Right;

            //T3
            t3Left = rand.Next(1000, 5000).ToString() + ":8:";
            t3Right = rand.Next(5000, 10000).ToString() + ":8:";
            t3Final = t3Right;

            return s + t1Final + t1Left + t1Right + t2Final + t2Left + t2Right + t3Final + t3Left + t3Right + ":2";
        }

    }
}
